local spellNames = {"Counterspell", "Counter Shot", "Mind Freeze", "Strangulate", "Solar Beam", "Rebuke", "Silance", "Kick", "Wind Shear", "Pummel", "Spear Hand Strike"}
local f = CreateFrame("Frame")
SLASH_ENDLESSINTERRUPT1 = "/endlessinterrupt"
f:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
RegisterAddonMessagePrefix("EndlessInterrupt")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("PLAYER_LOGIN")
local popup = CreateFrame("Frame")
popup:SetWidth(800)
popup:SetHeight(100)
popup:ClearAllPoints()
popup:SetPoint("TOP")
popup:SetMovable(false)
popup:EnableMouse(false)
popup:RegisterForDrag("LeftButton")
popup:SetFrameLevel(3)
popup:SetScript("OnDragStart", popup.StartMoving)
popup:SetScript("OnDragStop", function(self)
	local point, relativeTo, relativePoint, xOffset, yOffset = self:GetPoint(1)
	EnRT_InterruptPosition = {}
	EnRT_InterruptPosition.point = point
	EnRT_InterruptPosition.relativeTo = relativeTo
	EnRT_InterruptPosition.relativePoint = relativePoint
	EnRT_InterruptPosition.xOffset = xOffset
	EnRT_InterruptPosition.yOffset = yOffset
	self:StopMovingOrSizing()
end)
local text = popup:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
text:SetFont("Fonts\\FRIZQT__.TTF", 60)
text:SetPoint("CENTER")
local function handler(msg, editbox)
	if EnRT_InterruptEnabled then
		if msg == "toggle" then
			text:SetText("NEXT INTERRUPT IS YOURS!")
			popup:SetMovable(true)
			popup:EnableMouse(true)
			popup:Show()
			C_Timer.After(7, function() 
				popup:Hide()
				popup:SetMovable(false)
				popup:EnableMouse(false)
			end)
		elseif not msg:match(";") then
			RunScript("EnRT_InterruptList = " .. msg)
		end
	end
end
SlashCmdList["ENDLESSINTERRUPT"] = handler
f:SetScript("OnEvent", function(self, event, ...)
	if EnRT_InterruptEnabled then
		if event == "UNIT_SPELLCAST_SUCCEEDED" and EnRT_InterruptList ~= nil then
			local unit, spell = ...
			if unit == "player" then
				if Endless_Contains(spellNames, spell) then
					popup:Hide()
					local nextIndex = Endless_Contains(EnRT_InterruptList, Ambiguate(UnitName("player"),"short"))
					if nextIndex ~= false then
						if nextIndex == #EnRT_InterruptList then
							nextIndex = 1
						else
							nextIndex = nextIndex + 1
						end
						if UnitIsConnected(EnRT_InterruptList[nextIndex]) and IsInRaid() then
							SendAddonMessage("EndlessInterrupt", "", "WHISPER", EnRT_InterruptList[nextIndex])
						end
					end
				end
			end
		elseif event == "CHAT_MSG_ADDON" then
			local prefix, msg, channel, sender = ...
			if prefix == "EndlessInterrupt" then
				text:SetText("NEXT INTERRUPT IS YOURS!")
				popup:Show()
				C_Timer.After(7, function() 
					popup:Hide()
				end)
			end
		end
	end
	if event == "PLAYER_LOGIN" then
		if EnRT_InterruptEnabled == nil then EnRT_InterruptEnabled = true end
		if EnRT_InterruptPosition ~= nil then
			popup:ClearAllPoints()
			popup:SetPoint(EnRT_InterruptPosition.point, EnRT_InterruptPosition.relativeTo, EnRT_InterruptPosition.relativePoint, EnRT_InterruptPosition.xOffset, EnRT_InterruptPosition.yOffset)
		end
	end
end)
--[[
	Checking if a table contains a given value and if it does, what index is the value located at
	param(arr) table
	param(value) T - value to check exists
	return boolean or integer / returns false if the table does not contain the value otherwise it returns the index of where the value is locatedd
]]
function Endless_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end